This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 907027

Summary: Review Request: rapidxml - Fast XML parser
Product: [Fedora] Fedora Reporter: Miro Hrončok <mhroncok>
Component: Package ReviewAssignee: T.C. Hollingsworth <tchollingsworth>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: notting, package-review, pmachata, praiskup, tchollingsworth, volker27
Target Milestone: ---Flags: tchollingsworth: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-04-27 23:48:26 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 907032    

Description Miro Hrončok 2013-02-02 14:05:48 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/rapidxml.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/rapidxml-1.13-1.fc18.src.rpm

Description:

RapidXml is an attempt to create the fastest XML parser possible, while
retaining usability, portability and reasonable W3C compatibility. It is an
in-situ parser written in modern C++, with parsing speed approaching that of
strlen function executed on the same data.

Fedora Account System Username: churchyard
Comment 1 Volker Fröhlich 2013-02-25 17:39:58 EST
Hm, that file is actually part of boost-devel already, as mentioned on http://rapidxml.sourceforge.net.

It could be considered a bundle there. I'd suggest to discuss that with the boost maintainers, in case you haven't already.
Comment 2 Miro Hrončok 2013-02-25 18:41:22 EST
Thnaks for letting me know, will talk to them.
Comment 3 Petr Machata 2013-02-25 20:09:36 EST
This indeed does look like bundling.  RapidXML is not a part of Boost API, it seems to be an implementation detail, much like e.g. ICU is.  I'll look into what the motivation was for doing it this way, and whether decoupling the two would be reasonable.
Comment 4 T.C. Hollingsworth 2013-04-19 02:17:27 EDT
This doesn't install the library, just the headers?
Comment 5 Miro Hrončok 2013-04-19 04:24:58 EDT
It is implemented in headers (silly).
Comment 6 T.C. Hollingsworth 2013-04-19 18:35:39 EDT
Ah, the completely empty main package confused me.  Please at least make that package depend on the -devel package.  Packages in the repo that do absolutely nothing aren't very nice.

It seems to me this is effectively a static library (albeit one that is compiled every time it's included).  You'd want to track it in the same way for all the same reasons (e.g. if a security flaw is found in it you'd want to rebuild everything that uses it).

So please follow the guidelines for static libraries:
http://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Static_Libraries

(Basically, just add "Provides: rapidxml-static = %{version}-%{release}" to -devel.)
Comment 7 Miro Hrončok 2013-04-20 14:08:18 EDT
(In reply to comment #6)
> Ah, the completely empty main package confused me.  Please at least make
> that package depend on the -devel package.  Packages in the repo that do
> absolutely nothing aren't very nice.
There is no empty "main" package produced, only -devel.

> (Basically, just add "Provides: rapidxml-static = %{version}-%{release}" to
> -devel.)
Done.

Spec URL: https://raw.github.com/hroncok/SPECS/master/rapidxml.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/rapidxml-1.13-2.fc18.src.rpm

Peter, how you see the (de)bundling issue now? Any news?
Comment 8 T.C. Hollingsworth 2013-04-20 14:29:55 EDT
Package APPROVED
Comment 9 Petr Machata 2013-04-22 06:37:32 EDT
> Peter, how you see the (de)bundling issue now? Any news?

I haven't had time to look into it yet.
Comment 10 Miro Hrončok 2013-04-22 06:48:57 EDT
Anyway, this package should not interact or conflicts with boost-devel:

$ rpm -q -l boost-devel | grep rapidxml
/usr/include/boost/property_tree/detail/rapidxml.hpp
/usr/include/boost/property_tree/detail/xml_parser_read_rapidxml.hpp
$ rpm -q -l rapidxml-devel
/usr/include/rapidxml.h
/usr/include/rapidxml_iterators.h
/usr/include/rapidxml_print.h
/usr/include/rapidxml_utils.h
/usr/share/doc/rapidxml-devel-1.13
/usr/share/doc/rapidxml-devel-1.13/license.txt
/usr/share/doc/rapidxml-devel-1.13/manual.html
Comment 11 Miro Hrončok 2013-04-22 06:49:49 EDT
New Package SCM Request
=======================
Package Name: rapidxml
Short Description: Fast XML parser
Owners: churchyard
Branches: f17 f18 f19
Comment 12 Jon Ciesla 2013-04-22 09:17:45 EDT
Git done (by process-git-requests).
Comment 13 Petr Machata 2013-04-22 19:10:59 EDT
(In reply to comment #10)
> Anyway, this package should not interact or conflicts with boost-devel:

It wouldn't.  It's renamed and in a separate namespace.

It would still be worth it to unbundle it though.  I looked now, and it doesn't seem to be awfully different.  There's a bunch of renames (s/assert/BOOST_ASSERT/ must be like half of the changes) and a couple of what seems to be backport-worthy changes.  Some changes might be instances of RapidXML getting fixed and Boost not picking up that change.  It seems the header could be reworked into a little shim that just translates RapidXML names to what the rest of Boost expects.
Comment 14 Fedora Update System 2013-04-23 05:51:24 EDT
rapidxml-1.13-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/rapidxml-1.13-2.fc19
Comment 15 Fedora Update System 2013-04-23 05:52:00 EDT
rapidxml-1.13-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/rapidxml-1.13-2.fc18
Comment 16 Fedora Update System 2013-04-23 05:52:37 EDT
rapidxml-1.13-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/rapidxml-1.13-2.fc17
Comment 17 Fedora Update System 2013-04-23 12:45:06 EDT
rapidxml-1.13-2.fc19 has been pushed to the Fedora 19 testing repository.
Comment 18 Fedora Update System 2013-04-27 23:48:29 EDT
rapidxml-1.13-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 19 Fedora Update System 2013-05-01 23:52:11 EDT
rapidxml-1.13-2.fc17 has been pushed to the Fedora 17 stable repository.
Comment 20 Fedora Update System 2013-05-01 23:52:35 EDT
rapidxml-1.13-2.fc18 has been pushed to the Fedora 18 stable repository.